set echo on

WITH year_months AS (
        SELECT TO_CHAR(
                  ADD_MONTHS( 
                     DATE '2004-01-01', ROWNUM-1 ), 'YYYYMM' ) AS year_month
        FROM   dual
        CONNECT BY ROWNUM < 12
        )
,    customer_names AS (
        SELECT DISTINCT name
        FROM   customer_orders
        )
SELECT sq.name
,      sq.year_month
,      NVL(co.total_amount,0) AS total_amount
FROM  (
       SELECT name
       ,      TO_CHAR(dt,'YYYYMM') AS year_month
       ,      SUM(amt)             AS total_amount
       FROM   customer_orders
       GROUP  BY
              name
       ,      TO_CHAR(dt,'YYYYMM')
      ) co
,    (
      SELECT *
      FROM   customer_names
      ,      year_months
     ) sq
WHERE  sq.year_month = co.year_month (+)
AND    sq.name = co.name (+)
ORDER  BY
       sq.name
,      sq.year_month;

